package de.intevation.flys.importer;

import java.math.BigDecimal;
import java.util.List;

import org.hibernate.Session;
import org.hibernate.Query;

import de.intevation.flys.model.DischargeTable;
import de.intevation.flys.model.DischargeTableValue;


public class ImportDischargeTableValue
{
    private Integer id;

    private BigDecimal q;
    private BigDecimal w;

    private ImportDischargeTable dischargeTable;

    private DischargeTableValue peer;


    public ImportDischargeTableValue() {
    }


    public ImportDischargeTableValue(BigDecimal q, BigDecimal w) {
        this.dischargeTable = dischargeTable;
        this.q              = q;
        this.w              = w;
    }


    public DischargeTableValue getPeer(DischargeTable dischargeTable) {
        if (peer == null) {
            Session session = Importer.sessionHolder.get();

            Query query = session.createQuery(
                "from DischargeTableValue where " +
                "dischargeTable.id=:tableId and q=:q and w=:w");
            query.setParameter("tableId", dischargeTable.getId());
            query.setParameter("q", q);
            query.setParameter("w", w);

            List<DischargeTableValue> dischargeTableValues = query.list();
            if (dischargeTableValues.isEmpty()) {
                peer = new DischargeTableValue(dischargeTable, q, w);
                session.save(peer);
            }
            else {
                peer = dischargeTableValues.get(0);
            }
        }

        return peer;
    }
}
